const Fission = {
	mPrefBranch: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.fission.").QueryInterface(Components.interfaces.nsIPrefBranch2),

/* ........ (Un)initialization .............. */

	onLoad: function()
	{
		if (!window.gProgressMeterPanel)
		{
			setTimeout(function() { Fission.onLoad(); }, 100);
			return;
		}
		if (!this.mProgressPanel)
		{
			this.mProgressPanel = gProgressMeterPanel;
			this.mPrefBranch.addObserver("", this, false);			
		}
		if (!((gURLBar = document.getElementById("urlbar"))))
		{
			return;
		}
		this.mProgressBar = document.getElementById("statusbar-icon");
		
		var iconize = this.getPref("iconize");
		if (iconize)
		{
			var iconBox = document.getElementById("lock-icon").parentNode;
			iconBox.insertBefore(this.mProgressBar, iconBox.firstChild);
		}
		else
		{
			gURLBar.appendChild(this.mProgressBar);
		}
		if (this.getPref("textify"))
		{
			this.textify();
		}
		if (this.getPref("linkify"))
		{
			this.linkify();
		}
		this.updateBackgroundColor();
		
		gProgressMeterPanel.hidden = true;
		gProgressMeterPanel = this;
		
		gURLBar.setAttribute("fission", (iconize)?"icon":"fusion");
		gURLBar.addEventListener("ValueChange", this.onValueChange_urlbar, true);
		
		this.mLoaded = true;
	},

	textify: function()
	{
		if (!this.mText)
		{
			this.mText = document.createElement("label");
			this.mText.setAttribute("id", "fission-status");
			this.mText.setAttribute("crop", "right");
			this.mText.setAttribute("onclick", "this.value='';");
			
			eval("nsBrowserStatusHandler.prototype.updateStatusField = " + nsBrowserStatusHandler.prototype.updateStatusField.toString().replace("{", "$& if (Fission.mText && Fission.mText.parentNode && Fission.mText.value != (this.status || this.defaultStatus)) Fission.mText.value = this.status || this.defaultStatus;"));
		}
		var iconBox = document.getElementById("lock-icon").parentNode;
		iconBox.insertBefore(this.mText, iconBox.firstChild);
	},

	linkify: function()
	{
		if (!/Fission/.test(nsBrowserStatusHandler.prototype.setOverLink))
		{
			eval("nsBrowserStatusHandler.prototype.setOverLink = " + nsBrowserStatusHandler.prototype.setOverLink.toString().replace("{", '$& \
				if (link && Fission.mLinkified && content.location.href != "about:blank") \
				{ \
					if (!this.__Fission_value) \
						this.__Fission_value = gURLBar.value; \
					if (gURLBar.getAttribute("fission-link") != link) \
						gURLBar.setAttribute("fission-link", (gURLBar.value = link)); \
				} \
				else if (this.__Fission_value) \
				{ \
					if (gURLBar.value == this.overLink) \
						gURLBar.value = this.__Fission_value; \
					delete this.__Fission_value; \
					gURLBar.removeAttribute("fission-link"); \
				}'));
		}
		this.mLinkified = true;
	},

	onUnload: function(aQuit)
	{
		if (this.mLoaded)
		{
			this.updateBackgroundColor(true);
			this.mLinkified = false;
			
			gProgressMeterPanel = this.mProgressPanel;
			gProgressMeterPanel.appendChild(this.mProgressBar);
			gProgressMeterPanel.hidden = false;
			
			gURLBar.setAttribute("fission", "");
			gURLBar.removeEventListener("ValueChange", this.onValueChange_urlbar, true);
			this.mLoaded = false;
		}
		if (this.mText && this.mText.parentNode)
		{
			this.mText.parentNode.removeChild(this.mText);
		}
		if (aQuit)
		{
			this.mPrefBranch.removeObserver("", this);
			
			this.mProgressPanel = null;
			this.mProgressBar = null;
			this.mText = null;
			
			this.onLoad = function() { };
		}
	},

/* ........ State Change Observers .............. */

	set collapsed(aValue)
	{
		if (aValue && this.mProgressBar.value != 100)
		{
			this.mProgressBar.value = 100;
		}
	},

	onValueChange_urlbar: function(aEvent)
	{
		if (aEvent.originalTarget == Fission.mProgressBar)
		{
			this.setAttribute("progress", Fission.mProgressBar.value);
		}
	},

	observe: function(aSubject, aTopic, aData)
	{
		if (aTopic == "nsPref:changed" && this.mLoaded)
		{
			switch (aData)
			{
			case "color":
				this.updateBackgroundColor();
				break;
			case "iconize":
			case "textify":
				setTimeout(function() { Fission.onUnload(); Fission.onLoad(); }, 0);
				break;
			case "linkify":
				if ((this.mLinkified = this.getPref(aData, false)))
				{
					this.linkify();
				}
				break;
			}
		}
	},

/* ........ Auxiliary Functions .............. */

	updateBackgroundColor: function(aReset)
	{
		document.getAnonymousElementByAttribute(this.mProgressBar, "class", "progress-bar").style.background = (!aReset)?this.getPref("color", ""):"";
	},

	getPref: function(aName, aDefault)
	{
		try
		{
			var pb = this.mPrefBranch;
			switch (pb.getPrefType(aName))
			{
			case pb.PREF_STRING:
				return pb.getCharPref(aName);
			case pb.PREF_BOOL:
				return pb.getBoolPref(aName);
			case pb.PREF_INT:
				return pb.getIntPref(aName);
			}
		}
		catch (ex) { }
		
		return aDefault;
	}
};

window.addEventListener("load", function() { Fission.onLoad(); }, false);
window.addEventListener("unload", function() { Fission.onUnload(true); }, false);
